package lbi;

import lbi.utils.Cronos;

public class MaximalSubSequence {

	public static void main(String[] args) {
		final int N = 100000;
		// generate random numbers
		int []a = new int[N];
		for(int i=0; i<N; ++i)
			a[i] = (int)(Math.random()*200) - 100;

		// quadratic time version
		Cronos t = new Cronos();
    	t.start();
    	
    	int max_so_far = 0;
    	for(int i=0; i<N; ++i) {
    		int sum_sub = 0;
    		for(int j=i; j<N; ++j) {
    			sum_sub += a[j];
    			if(sum_sub > max_so_far)
    				max_so_far = sum_sub;    			
    		}
    	}
    	System.out.println("Max subsequence sum = " + max_so_far);

    	t.stop();
        System.out.println("Elapsed time (s): " + t.elapsed());

        // linear time version -- see https://en.wikipedia.org/wiki/Maximum_subarray_problem
    	t.start();
    	
    	max_so_far = 0;
    	int max_ending_here = 0;
    	for(int v : a) {
    		max_ending_here = Math.max(0, max_ending_here + v);
    		max_so_far = Math.max(max_so_far, max_ending_here);
    	}
    	System.out.println("Max subsequence sum = " + max_so_far);

    	t.stop();
        System.out.println("Elapsed time (s): " + t.elapsed());
	}

}
