package lbi.file.sample;

import java.io.BufferedReader;
import java.io.IOException;

import lbi.utils.Cronos;
import lbi.utils.IOUtil;

/** Count the number of rows and columns in a CSV file */
public class RowCount {
   public static void main(String[] args) throws IOException {
        if (args.length != 1) {
            System.out.println(
                    "Usage: java RowCount inputFile");
            System.exit(0);
        }
    	Cronos t = new Cronos();
    	t.start();
        BufferedReader input = IOUtil.getReader(args[0]);
        int nrows = 0, 
        	minc = Integer.MAX_VALUE, 
        	maxc = Integer.MIN_VALUE;
        String[] tokens;
        while ((tokens = IOUtil.readTokens(input)) != null) {
        	++nrows;
        	int nc = tokens.length;
        	if( nc < minc ) minc = nc;
        	if( nc > maxc ) maxc = nc;
        }
        input.close();
        t.stop();
        System.out.println("Rows: " + nrows);
        System.out.println("Min columns: " + minc);
        System.out.println("Max columns: " + maxc);
        System.out.println("Elapsed time (s): " + t.elapsed());
   }
}
