package lbi.file.sample;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/** Count the number of rows and columns in a CSV file */
public class RowCountScanner {
    public static void main(String[] args) throws FileNotFoundException {
        if (args.length != 1) {
            System.out.println("Usage: java RowCount inputFile");
            System.exit(0);
        }
        Scanner input = new Scanner(new File(args[0]));
         int nrows = 0, 
        	minc = Integer.MAX_VALUE, 
        	maxc = Integer.MIN_VALUE;
         while( input.hasNextLine() ) {
        	String line=input.nextLine();
        	++nrows;
        	int nc = line.split(",").length;
        	if( nc < minc ) minc = nc;
        	if( nc > maxc ) maxc = nc;
        }
        input.close();
        System.out.println("Rows: " + nrows);
        System.out.println("Min columns: " + minc);
        System.out.println("Max columns: " + maxc);
    }
}
