package lbi.file.sample;

import java.io.*;

import lbi.utils.IOUtil;

/** Count columns from a CSV file */
public class Select {

    public static int select(BufferedReader in, int[] cols, PrintWriter out) throws
            IOException {
        int nrows = 0;
        int nCols = cols.length;
        String[] tokens;
        while ((tokens = IOUtil.readTokens(in)) != null) {
            for (int i = 0; i < nCols - 1; ++i) {
                out.print(tokens[cols[i]]);
                out.print(",");
            }
            out.println(tokens[cols[nCols-1]]);
            ++nrows;
        }
        return nrows;
    }

    public static void main(String[] args) throws IOException {
        if (args.length < 3) {
            System.out.println(
                    "Usage: java Select inputFile outputFile colNumber ...");
            System.exit(0);
        }
        BufferedReader input = IOUtil.getReader(args[0]);
        PrintWriter output = IOUtil.getWriter(args[1]);
        int nCol = args.length - 2;
        int[] cols = new int[nCol];
        for (int i = 0; i < nCol; ++i)
            cols[i] = Integer.parseInt(args[i + 2]);
        int nrows = select(input, cols, output);
        System.out.println("Rows processed: " + nrows);
        input.close();
        output.close();
    }
}
