package lbi.file.sample;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;

import lbi.utils.IOUtil;

import org.w3c.dom.*;
import org.xml.sax.SAXException;

/** Sample recursive traversal of a DOM Document */
public class XMLSample {
	
	public static void recurse(Element e, String offset) {
        NodeList rows = e.getChildNodes();
        int nrows = rows.getLength();
		NamedNodeMap atts = e.getAttributes();
    	int natts = atts.getLength();
     	System.out.println(offset+e.getTagName()+"("+nrows+","+natts+")");
     	offset += "  ";
        for(int i=0; i<nrows; ++i) {
        	Node c = rows.item(i);
        	if( c.getNodeType() != Node.ELEMENT_NODE )
        		continue;
         	Element child = (Element)c;
         	recurse(child, offset);
        }
	}

	public static void main(String[] args) throws IOException, ParserConfigurationException, SAXException {
//        Document d = IOUtil.getDocument("http://pages.di.unipi.it/ruggieri/teaching/lbi//census_elements.xml");
        Document d = IOUtil.getDocument("http://pages.di.unipi.it/ruggieri/teaching/lbi//census_row.xml");
        Element root = d.getDocumentElement();
        recurse(root,"");
	}

}
